unit ufrmOrder;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ufrmTemplate, ulibTrDBTables, ExtCtrls, Placemnt, Menus, StdCtrls, Grids,
  DBGrids, DBGridPlus, ulibTrDBGrids, ComCtrls, ulibTrDBCtrls, ulibTrCtrls,
  Buttons, Mask, DBCtrls, DBCGrids, Db, ToolEdit, RXDBCtrl;

type

  TOrderKind = (okAsc, okDesc);

  TfrmOrder = class(TfrmTemplate)
    Panel2: TPanel;
    Label1: TrLabel;
    DBEdit1: TrDBEdit;
    Label2: TrLabel;
    Label3: TrLabel;
    Label4: TrLabel;
    Label5: TrLabel;
    Label14: TrLabel;
    Label15: TrLabel;
    DBEdit15: TrDBEdit;
    Label16: TrLabel;
    Label17: TrLabel;
    Label18: TrLabel;
    DBEdit18: TrDBEdit;
    Label19: TrLabel;
    DBEdit19: TrDBEdit;
    Label20: TrLabel;
    DBEdit20: TrDBEdit;
    Label21: TrLabel;
    DBEdit21: TrDBEdit;
    rDBLookupComboBox1: TrDBLookupComboBox;
    rDBLookupComboBox2: TrDBLookupComboBox;
    rDBLookupComboBox3: TrDBLookupComboBox;
    DBText1: TDBText;
    DBText2: TDBText;
    rDBLookupComboBox4: TrDBLookupComboBox;
    rDBLookupComboBox5: TrDBLookupComboBox;
    Panel4: TPanel;
    DBCtrlGrid1: TrDBCtrlGrid;
    DBEdit16: TrDBEdit;
    DBEdit17: TrDBEdit;
    rDBLookupComboBox6: TrDBLookupComboBox;
    DBEdit2: TrDBEdit;
    DBEdit5: TrDBEdit;
    DBEdit14: TrDBEdit;
    HeaderControl1: THeaderControl;
    GroupBox1: TGroupBox;
    Label6: TrLabel;
    Label7: TrLabel;
    Label8: TrLabel;
    Label9: TrLabel;
    Label10: TrLabel;
    Label11: TrLabel;
    Label12: TrLabel;
    Label13: TrLabel;
    DBEdit6: TrDBEdit;
    DBEdit7: TrDBEdit;
    DBEdit8: TrDBEdit;
    DBEdit9: TrDBEdit;
    DBEdit10: TrDBEdit;
    DBEdit11: TrDBEdit;
    DBEdit12: TrDBEdit;
    DBEdit13: TrDBEdit;
    spTeilprojekt: TSpeedButton;
    SpeedButton1: TSpeedButton;
    OrderByBmp: TImageList;
    DBDateEdit1: TDBDateEdit;
    DBDateEdit2: TDBDateEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HeaderControl1SectionResize(HeaderControl: THeaderControl; Section: THeaderSection);
    procedure rDBLookupComboBox1DblClick(Sender: TObject);
    procedure rDBLookupComboBox4DblClick(Sender: TObject);
    procedure Panel4Resize(Sender: TObject);
    procedure HeaderControl1SectionClick(HeaderControl: THeaderControl; Section: THeaderSection);
    procedure HeaderControl1DrawSection(HeaderControl: THeaderControl;
      Section: THeaderSection; const Rect: TRect; Pressed: Boolean);
  private
    { Private-Deklarationen }
    OrderSection: THeaderSection;
    OrderKind: TOrderKind;
    procedure AllignGridControls;
  public
    { Public-Deklarationen }
  end;

var
  frmOrder: TfrmOrder;

implementation

uses
  udmdOrder
  ,ufrmOrderFF
  ,ufrmCustomer
  ,ufrmEmployee
  ,umodTemplateGlobal
  ;

{$R *.DFM}

procedure TfrmOrder.FormCreate(Sender: TObject);
begin
  MasterDataLink.DataSource := dmdOrder.sqryrOrder;
  frmFastFilter := TfrmOrderFF.Create(Application);
  inherited;
  AllignGridControls;
  Panel4Resize(self);
end;

procedure TfrmOrder.FormDestroy(Sender: TObject);
begin
  inherited;
  frmOrder := nil;
end;

procedure TfrmOrder.HeaderControl1SectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
begin
  inherited;
  AllignGridControls;
end;

procedure TfrmOrder.AllignGridControls;
Var i, nSec: Integer;
    aPanel: TPanel;
    nLeft, nWidth: Integer;
begin
  aPanel := TPanel(DBCtrlGrid1.Controls[0]);
  For nSec := 0 to HeaderControl1.Sections.Count-1 do begin
    nLeft := HeaderControl1.Sections[nSec].Left;
    nWidth := HeaderControl1.Sections[nSec].Width;
    For i:=0 to aPanel.ControlCount-1 do begin
      if (aPanel.Controls[i].Tag = nSec) then begin
        aPanel.Controls[i].Left := nLeft + 1;
        aPanel.Controls[i].Width := nWidth - 2;
{        if (aPanel.Controls[i].Left + aPanel.Controls[i].Width) > (DBCtrlGrid1.PanelWidth - 2) Then
          aPanel.Controls[i].Width := (DBCtrlGrid1.PanelWidth - 2 - aPanel.Controls[i].Left);}
      end
    end;
  End;
  DBCtrlGrid1.Refresh;
end;

procedure TfrmOrder.HeaderControl1SectionClick(HeaderControl: THeaderControl; Section: THeaderSection);
Var aParentControl: TWinControl;
    i: Integer;
    aDataLink: TFieldDataLink;
    sFieldName: String;
begin
  aParentControl := rDBLookupComboBox6.Parent;
  For i:=0 to aParentControl.ControlCount-1 do begin
    If (aParentControl.Controls[i].Tag = Section.Index) and (aParentControl.Controls[i] is TWinControl) then begin
      // re order
      aDataLink := TFieldDataLink(aParentControl.Controls[i].Perform(CM_GETDATALINK, 0, 0));
      if (aDataLink <> nil) and (aDataLink.Field.FieldKind = fkData) Then Begin
        sFieldName := aDataLink.Field.FieldName;
        if aParentControl.Controls[i] is TrDBLookupComboBox Then
          sFieldName := TrDBLookupComboBox(aParentControl.Controls[i]).LookupField;
        if (dmdOrder.qryrOrderItems.SQLOrderBy.Text = (sFieldName + ''#13#10)) Then Begin
          dmdOrder.qryrOrderItems.SQLOrderBy.Text := sFieldName + ' DESC';
          OrderSection := Section;
          OrderKind := okDesc;
        End else Begin
          dmdOrder.qryrOrderItems.SQLOrderBy.Text := sFieldName;
          OrderSection := Section;
          OrderKind := okAsc;
        End;
        HeaderControl1.Invalidate;
        dmdOrder.qryrOrderItems.ApplyFilter;
      End;
      TWinControl(aParentControl.Controls[i]).SetFocus;
      SendMessage(TWinControl(aParentControl.Controls[i]).Handle,EM_SETSEL,0,-1);
    End
  End;
End;

procedure TfrmOrder.rDBLookupComboBox1DblClick(Sender: TObject);
begin
  inherited;
  OpenWithKeyValues(TfrmCustomer.ClassName,[rDBLookupComboBox1.Field.Value]);
end;

procedure TfrmOrder.rDBLookupComboBox4DblClick(Sender: TObject);
begin
  inherited;
  OpenWithKeyValues(TfrmEmployee.ClassName,[rDBLookupComboBox4.Field.Value]);
end;

procedure TfrmOrder.Panel4Resize(Sender: TObject);
begin
  inherited;
  DBCtrlGrid1.RowCount := (Panel4.Height - DBCtrlGrid1.Top) div DBCtrlGrid1.PanelHeight;
end;

procedure TfrmOrder.HeaderControl1DrawSection(
  HeaderControl: THeaderControl; Section: THeaderSection;
  const Rect: TRect; Pressed: Boolean);
Const OrderKindBmp: array[TOrderKind] of Integer = (0,1);
Var   nLeft: Integer;
begin
  with HeaderControl.Canvas do
  begin
    TextOut(Rect.Left+2, Rect.Top, Section.Text);
    nLeft := TextWidth(Section.Text);
    if (dmdOrder.qryrOrderItems.SQLOrderBy.Text <> '') and (OrderSection = Section) Then Begin
      OrderByBmp.Draw(HeaderControl.Canvas, Rect.Left+nLeft, Rect.Top, OrderKindBmp[OrderKind]);
    End;
  end;
end;

initialization
  RegisterForm(TfrmOrder.ClassName,TfrmOrder,@frmOrder);

end.
